Index: issm/trunk/src/c/analyses/SealevelchangeAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/SealevelchangeAnalysis.cpp	(revision 27035)
+++ issm/trunk/src/c/analyses/SealevelchangeAnalysis.cpp	(revision 27232)
@@ -17,4 +17,13 @@
 void SealevelchangeAnalysis::CreateNodes(Nodes* nodes,IoModel* iomodel,bool isamr){/*{{{*/
 	::CreateNodes(nodes,iomodel,SealevelchangeAnalysisEnum,P1Enum);
+}/*}}}*/
+void SealevelchangeAnalysis::DeleteBarystaticContributionsParam(FemModel* femmodel){/*{{{*/
+	BarystaticContributions* barycontrib=NULL;
+	GenericParam<BarystaticContributions*>* barycontribparam=NULL;
+
+	barycontribparam = xDynamicCast<GenericParam<BarystaticContributions*>*>(femmodel->parameters->FindParamObject(BarystaticContributionsEnum));
+	barycontrib=barycontribparam->GetParameterValue();
+
+	delete barycontrib;
 }/*}}}*/
 int  SealevelchangeAnalysis::DofsPerNode(int** doflist,int domaintype,int approximation){/*{{{*/
@@ -115,4 +124,7 @@
 	IssmDouble  planetradius=0;
 	IssmDouble  planetarea=0;
+	IssmDouble  constant=0;
+	IssmDouble  rho_earth;
+	int		isgrd=0;
 	bool		selfattraction=false;
 	bool		elastic=false;
@@ -128,4 +140,6 @@
 	int     numoutputs;
 	char**  requestedoutputs = NULL;
+	int* recvcounts = NULL;
+	int* displs=NULL;
 
 	/*transition vectors: */
@@ -149,4 +163,5 @@
 	if(isexternal) parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.external.nature",SolidearthExternalNatureEnum));
 	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.runfrequency",SolidearthSettingsRunFrequencyEnum));
+	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.degacc",SolidearthSettingsDegreeAccuracyEnum));
 	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.reltol",SolidearthSettingsReltolEnum));
 	parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.settings.abstol",SolidearthSettingsAbstolEnum));
@@ -172,7 +187,7 @@
 	parameters->AddObject(new DoubleParam(CumBslcHydroEnum,0.0));
 	parameters->AddObject(new DoubleParam(CumGmtslcEnum,0.0));
-
 	/*compute planet area and plug into parameters:*/
 	iomodel->FetchData(&planetradius,"md.solidearth.planetradius");
+	iomodel->FetchData(&rho_earth,"md.materials.earth_density");
 	planetarea=4*M_PI*planetradius*planetradius;
 	parameters->AddObject(new DoubleParam(SolidearthPlanetAreaEnum,planetarea));
@@ -236,5 +251,6 @@
 
 	parameters->FindParam(&grdmodel,GrdModelEnum);
-	if(grdmodel==ElasticEnum){
+	parameters->FindParam(&isgrd,SolidearthSettingsGRDEnum);
+	if(grdmodel==ElasticEnum && isgrd){
 		/*Deal with elasticity {{{*/
 		iomodel->FetchData(&selfattraction,"md.solidearth.settings.selfattraction");
@@ -250,4 +266,7 @@
 		}
 
+		//default values
+		nt=1;
+		ntimesteps=1;
 		/*love numbers: */
 		if(viscous || elastic){
@@ -264,7 +283,7 @@
 
 			parameters->AddObject(new DoubleParam(SolidearthSettingsTimeAccEnum,timeacc));
-			parameters->AddObject(new DoubleMatParam(LoadLoveHEnum,love_h,ndeg,precomputednt));
-			parameters->AddObject(new DoubleMatParam(LoadLoveKEnum,love_k,ndeg,precomputednt));
-			parameters->AddObject(new DoubleMatParam(LoadLoveLEnum,love_l,ndeg,precomputednt));
+			//parameters->AddObject(new DoubleMatParam(LoadLoveHEnum,love_h,ndeg,precomputednt));
+			//parameters->AddObject(new DoubleMatParam(LoadLoveKEnum,love_k,ndeg,precomputednt));
+			//parameters->AddObject(new DoubleMatParam(LoadLoveLEnum,love_l,ndeg,precomputednt));
 
 			if (rotation){
@@ -277,7 +296,7 @@
 				parameters->AddObject(new DoubleMatParam(LovePolarMotionTransferFunctionColinearEnum,love_pmtf_colinear,1,precomputednt));
 				parameters->AddObject(new DoubleMatParam(LovePolarMotionTransferFunctionOrthogonalEnum,love_pmtf_ortho,1,precomputednt));
-				parameters->AddObject(new DoubleMatParam(TidalLoveHEnum,love_th,ndeg,precomputednt));
-				parameters->AddObject(new DoubleMatParam(TidalLoveKEnum,love_tk,ndeg,precomputednt));
-				parameters->AddObject(new DoubleMatParam(TidalLoveLEnum,love_tl,ndeg,precomputednt));
+				//parameters->AddObject(new DoubleMatParam(TidalLoveHEnum,love_th,ndeg,precomputednt));
+				//parameters->AddObject(new DoubleMatParam(TidalLoveKEnum,love_tk,ndeg,precomputednt));
+				//parameters->AddObject(new DoubleMatParam(TidalLoveLEnum,love_tl,ndeg,precomputednt));
 			}
 
@@ -308,15 +327,8 @@
 				}
 			}
-			else {
-				ntimesteps=1;
-				nt=1;
-			}
-
 #ifdef _HAVE_AD_
-			G_viscoelastic=xNew<IssmDouble>(M*ntimesteps,"t");
 			U_viscoelastic=xNew<IssmDouble>(M*ntimesteps,"t");
 			if(horiz)H_viscoelastic=xNew<IssmDouble>(M*ntimesteps,"t");
 #else
-			G_viscoelastic=xNew<IssmDouble>(M*ntimesteps);
 			U_viscoelastic=xNew<IssmDouble>(M*ntimesteps);
 			if(horiz)H_viscoelastic=xNew<IssmDouble>(M*ntimesteps);
@@ -324,99 +336,97 @@
 		}
 		if(selfattraction){
-#ifdef _HAVE_AD_
-			G_gravi=xNew<IssmDouble>(M,"t");
-#else
-			G_gravi=xNew<IssmDouble>(M);
-#endif
-		}
-
-		if(rotation) parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.lovenumbers.tk2secular",TidalLoveK2SecularEnum));
-		if(selfattraction){
-
 			/*compute combined legendre + love number (elastic green function):*/
 			m=DetermineLocalSize(M,IssmComm::GetComm());
 			GetOwnershipBoundariesFromRange(&lower_row,&upper_row,m,IssmComm::GetComm());
+#ifdef _HAVE_AD_
+			G_gravi=xNew<IssmDouble>(M,"t");
+			G_gravi_local=xNew<IssmDouble>(m,"t");
+			G_viscoelastic=xNew<IssmDouble>(M*ntimesteps,"t");
+			G_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps,"t");
+#else
+			G_gravi=xNew<IssmDouble>(M);
+			G_gravi_local=xNew<IssmDouble>(m);
+			G_viscoelastic=xNew<IssmDouble>(M*ntimesteps);
+			G_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps);
+#endif
 		}
 		if(viscous | elastic){
 #ifdef _HAVE_AD_
-			G_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps,"t");
 			U_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps,"t");
 			if(horiz)H_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps,"t");
 #else
-			G_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps);
 			U_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps);
 			if(horiz)H_viscoelastic_local=xNew<IssmDouble>(m*ntimesteps);
 #endif
 		}
-		if(selfattraction){
-#ifdef _HAVE_AD_
-			G_gravi_local=xNew<IssmDouble>(m,"t");
-#else
-			G_gravi_local=xNew<IssmDouble>(m);
-#endif
-		}
-
+
+		if(rotation) parameters->AddObject(iomodel->CopyConstantObject("md.solidearth.lovenumbers.tk2secular",TidalLoveK2SecularEnum));
+		constant=3/rho_earth/planetarea;
 		if(selfattraction){
 			for(int i=lower_row;i<upper_row;i++){
 				IssmDouble alpha,x;
 				alpha= reCast<IssmDouble>(i)*degacc * M_PI / 180.0;
-				G_gravi_local[i-lower_row]= .5/sin(alpha/2.0);
-			}
-		}
-		if(viscous | elastic){
-			for(int i=lower_row;i<upper_row;i++){
-				IssmDouble alpha,x;
-				alpha= reCast<IssmDouble>(i)*degacc * M_PI / 180.0;
-
-				for(int t=0;t<ntimesteps;t++){
-					G_viscoelastic_local[(i-lower_row)*ntimesteps+t]= (love_k[(ndeg-1)*precomputednt+t]-love_h[(ndeg-1)*precomputednt+t])*G_gravi_local[i-lower_row];
-					U_viscoelastic_local[(i-lower_row)*ntimesteps+t]= (love_h[(ndeg-1)*precomputednt+t])*G_gravi_local[i-lower_row];
-					if(horiz)H_viscoelastic_local[(i-lower_row)*ntimesteps+t]= 0; 
-				}
-
-				IssmDouble Pn = 0.; 
-				IssmDouble Pn1 = 0.; 
-				IssmDouble Pn2 = 0.; 
-				IssmDouble Pn_p = 0.; 
-				IssmDouble Pn_p1 = 0.; 
-				IssmDouble Pn_p2 = 0.; 
-
-				for (int n=0;n<ndeg;n++) {
-
-					/*compute legendre polynomials: P_n(cos\theta) & d P_n(cos\theta)/ d\theta: */
-					if(n==0){
-						Pn=1; 
-						Pn_p=0; 
+				G_gravi_local[i-lower_row]= constant*.5/sin(alpha/2.0);
+			}
+			if(viscous | elastic){
+				for(int i=lower_row;i<upper_row;i++){
+					IssmDouble alpha,x;
+					alpha= reCast<IssmDouble>(i)*degacc * M_PI / 180.0;
+
+					for(int t=0;t<ntimesteps;t++){
+						G_viscoelastic_local[(i-lower_row)*ntimesteps+t]= (1.0+love_k[(ndeg-1)*precomputednt+t]-love_h[(ndeg-1)*precomputednt+t])*G_gravi_local[i-lower_row];
+						U_viscoelastic_local[(i-lower_row)*ntimesteps+t]= (love_h[(ndeg-1)*precomputednt+t])*G_gravi_local[i-lower_row];
+						if(horiz)H_viscoelastic_local[(i-lower_row)*ntimesteps+t]= 0; 
 					}
-					else if(n==1){ 
-						Pn = cos(alpha); 
-						Pn_p = 1; 
+
+					IssmDouble Pn = 0.; 
+					IssmDouble Pn1 = 0.; 
+					IssmDouble Pn2 = 0.; 
+					IssmDouble Pn_p = 0.; 
+					IssmDouble Pn_p1 = 0.; 
+					IssmDouble Pn_p2 = 0.; 
+
+					for (int n=0;n<ndeg;n++) {
+
+						/*compute legendre polynomials: P_n(cos\theta) & d P_n(cos\theta)/ d\theta: */
+						if(n==0){
+							Pn=1; 
+							Pn_p=0; 
+						}
+						else if(n==1){ 
+							Pn = cos(alpha); 
+							Pn_p = 1; 
+						}
+						else{
+							Pn = ( (2*n-1)*cos(alpha)*Pn1 - (n-1)*Pn2 ) /n;
+							Pn_p = ( (2*n-1)*(Pn1+cos(alpha)*Pn_p1) - (n-1)*Pn_p2 ) /n;
+						}
+						Pn2=Pn1; Pn1=Pn;
+						Pn_p2=Pn_p1; Pn_p1=Pn_p;
+
+						for(int t=0;t<ntimesteps;t++){
+							IssmDouble deltalove_G;
+							IssmDouble deltalove_U;
+
+							deltalove_G = (love_k[n*precomputednt+t]-love_k[(ndeg-1)*precomputednt+t]-love_h[n*precomputednt+t]+love_h[(ndeg-1)*precomputednt+t]);
+							deltalove_U = (love_h[n*precomputednt+t]-love_h[(ndeg-1)*precomputednt+t]);
+
+							G_viscoelastic_local[(i-lower_row)*ntimesteps+t] += constant*deltalove_G*Pn;		                // gravitational potential 
+							U_viscoelastic_local[(i-lower_row)*ntimesteps+t] += constant*deltalove_U*Pn;		                // vertical (up) displacement 
+							if(horiz)H_viscoelastic_local[(i-lower_row)*ntimesteps+t] += constant*sin(alpha)*love_l[n*precomputednt+t]*Pn_p;		// horizontal displacements 
+						}
 					}
-					else{
-						Pn = ( (2*n-1)*cos(alpha)*Pn1 - (n-1)*Pn2 ) /n;
-						Pn_p = ( (2*n-1)*(Pn1+cos(alpha)*Pn_p1) - (n-1)*Pn_p2 ) /n;
+				}
+			}
+			else { //just copy G_gravi into G_viscoelastic
+				for(int i=lower_row;i<upper_row;i++){
+					for(int t=0;t<ntimesteps;t++){
+						G_viscoelastic_local[(i-lower_row)*ntimesteps+t]= G_gravi_local[i-lower_row];
 					}
-					Pn2=Pn1; Pn1=Pn;
-					Pn_p2=Pn_p1; Pn_p1=Pn_p;
-
-					for(int t=0;t<ntimesteps;t++){
-						IssmDouble deltalove_G;
-						IssmDouble deltalove_U;
-
-						deltalove_G = (love_k[n*precomputednt+t]-love_k[(ndeg-1)*precomputednt+t]-love_h[n*precomputednt+t]+love_h[(ndeg-1)*precomputednt+t]);
-						deltalove_U = (love_h[n*precomputednt+t]-love_h[(ndeg-1)*precomputednt+t]);
-
-						G_viscoelastic_local[(i-lower_row)*ntimesteps+t] += deltalove_G*Pn;		                // gravitational potential 
-						U_viscoelastic_local[(i-lower_row)*ntimesteps+t] += deltalove_U*Pn;		                // vertical (up) displacement 
-						if(horiz)H_viscoelastic_local[(i-lower_row)*ntimesteps+t] += sin(alpha)*love_l[n*precomputednt+t]*Pn_p;		// horizontal displacements 
-					}
-				}
-			}
-		}
-		if(selfattraction){
-
+				}
+			}
 			/*merge G_viscoelastic_local into G_viscoelastic; U_viscoelastic_local into U_viscoelastic; H_viscoelastic_local to H_viscoelastic:{{{*/
-			int* recvcounts=xNew<int>(IssmComm::GetSize());
-			int* displs=xNew<int>(IssmComm::GetSize());
+			recvcounts=xNew<int>(IssmComm::GetSize());
+			displs=xNew<int>(IssmComm::GetSize());
 			int  rc;
 			int  offset;
@@ -424,18 +434,15 @@
 			//deal with selfattraction first: 
 			ISSM_MPI_Allgather(&m,1,ISSM_MPI_INT,recvcounts,1,ISSM_MPI_INT,IssmComm::GetComm());
-
 			/*displs: */
 			ISSM_MPI_Allgather(&lower_row,1,ISSM_MPI_INT,displs,1,ISSM_MPI_INT,IssmComm::GetComm());
-
 			/*All gather:*/
 			ISSM_MPI_Allgatherv(G_gravi_local, m, ISSM_MPI_DOUBLE, G_gravi, recvcounts, displs, ISSM_MPI_DOUBLE,IssmComm::GetComm());
 
+			rc=m*ntimesteps;
+			offset=lower_row*ntimesteps;
+			ISSM_MPI_Allgather(&rc,1,ISSM_MPI_INT,recvcounts,1,ISSM_MPI_INT,IssmComm::GetComm());
+			ISSM_MPI_Allgather(&offset,1,ISSM_MPI_INT,displs,1,ISSM_MPI_INT,IssmComm::GetComm());
+			ISSM_MPI_Allgatherv(G_viscoelastic_local, m*ntimesteps, ISSM_MPI_DOUBLE, G_viscoelastic, recvcounts, displs, ISSM_MPI_DOUBLE,IssmComm::GetComm());
 			if(elastic){
-				rc=m*ntimesteps;
-				offset=lower_row*ntimesteps;
-				ISSM_MPI_Allgather(&rc,1,ISSM_MPI_INT,recvcounts,1,ISSM_MPI_INT,IssmComm::GetComm());
-				ISSM_MPI_Allgather(&offset,1,ISSM_MPI_INT,displs,1,ISSM_MPI_INT,IssmComm::GetComm());
-
-				ISSM_MPI_Allgatherv(G_viscoelastic_local, m*ntimesteps, ISSM_MPI_DOUBLE, G_viscoelastic, recvcounts, displs, ISSM_MPI_DOUBLE,IssmComm::GetComm());
 				ISSM_MPI_Allgatherv(U_viscoelastic_local, m*ntimesteps, ISSM_MPI_DOUBLE, U_viscoelastic, recvcounts, displs, ISSM_MPI_DOUBLE,IssmComm::GetComm());
 				if(horiz)ISSM_MPI_Allgatherv(H_viscoelastic_local, m*ntimesteps, ISSM_MPI_DOUBLE, H_viscoelastic, recvcounts, displs, ISSM_MPI_DOUBLE,IssmComm::GetComm());
@@ -448,7 +455,9 @@
 			/*Avoid singularity at 0: */
 			G_gravi[0]=G_gravi[1];
+			for(int t=0;t<ntimesteps;t++){
+				G_viscoelastic[t]=G_viscoelastic[ntimesteps+t];
+			}
 			if(elastic){
 				for(int t=0;t<ntimesteps;t++){
-					G_viscoelastic[t]=G_viscoelastic[ntimesteps+t];
 					U_viscoelastic[t]=U_viscoelastic[ntimesteps+t];
 					if(horiz)H_viscoelastic[t]=H_viscoelastic[ntimesteps+t];
@@ -463,5 +472,5 @@
 				G_viscoelastic_interpolated=xNew<IssmDouble>(M*nt,"t");
 				U_viscoelastic_interpolated=xNew<IssmDouble>(M*nt,"t");
-				if(horiz)H_viscoelastic_interpolated=xNew<IssmDouble>(M*nt,"t");
+				if(horiz) H_viscoelastic_interpolated=xNew<IssmDouble>(M*nt,"t");
 				if(rotation){
 					Pmtf_col_interpolated=xNew<IssmDouble>(nt,"t");
@@ -475,5 +484,5 @@
 				G_viscoelastic_interpolated=xNew<IssmDouble>(M*nt);
 				U_viscoelastic_interpolated=xNew<IssmDouble>(M*nt);
-				if(horiz)H_viscoelastic_interpolated=xNew<IssmDouble>(M*nt);
+				if(horiz) H_viscoelastic_interpolated=xNew<IssmDouble>(M*nt);
 				if(rotation){
 					Pmtf_col_interpolated=xNew<IssmDouble>(nt);
@@ -485,10 +494,8 @@
 				}
 #endif
-
 				for(int t=0;t<nt;t++){
 					IssmDouble lincoeff;
 					IssmDouble viscoelastic_time=t*timeacc;
 					int        timeindex2=-1;
-
 					/*Find a way to interpolate precomputed Gkernels to our solution time stepping:*/
 					if(t!=0){
@@ -509,5 +516,4 @@
 
 					for(int index=0;index<M;index++){
-
 						int timeindex=index*nt+t;
 						int timepreindex= index*ntimesteps+timeindex2;
@@ -527,48 +533,57 @@
 					}
 				}
-
-			}
-			else if(elastic){
+			}
+			else {
+
 				nt=1; //in elastic, or if we run only selfattraction, we need only one step
 #ifdef _HAVE_AD_
-				G_viscoelastic_interpolated=G_viscoelastic;
-				U_viscoelastic_interpolated=U_viscoelastic;
-				if(horiz)H_viscoelastic_interpolated=H_viscoelastic;
+				G_viscoelastic_interpolated=xNew<IssmDouble>(M,"t");
 #else
-				G_viscoelastic_interpolated=G_viscoelastic;
-				U_viscoelastic_interpolated=U_viscoelastic;
-				if(horiz)H_viscoelastic_interpolated=H_viscoelastic;
+				G_viscoelastic_interpolated=xNew<IssmDouble>(M);
 #endif
-
-				if(rotation){ //if this cpu handles degree 2
+				xMemCpy<IssmDouble>(G_viscoelastic_interpolated,G_viscoelastic,M);
+
+				if(elastic){
 #ifdef _HAVE_AD_
-					Pmtf_col_interpolated=xNew<IssmDouble>(1,"t");
-					Pmtf_ortho_interpolated=xNew<IssmDouble>(1,"t");
-					Pmtf_z_interpolated=xNew<IssmDouble>(1,"t");
-					Love_tk2_interpolated=xNew<IssmDouble>(1,"t");
-					Love_th2_interpolated=xNew<IssmDouble>(1,"t");
-					if (horiz) Love_tl2_interpolated=xNew<IssmDouble>(1,"t");
+					U_viscoelastic_interpolated=xNew<IssmDouble>(M,"t");
+					if (horiz) H_viscoelastic_interpolated=xNew<IssmDouble>(M,"t");
 #else
-					Pmtf_col_interpolated=xNew<IssmDouble>(1);
-					Pmtf_ortho_interpolated=xNew<IssmDouble>(1);
-					Pmtf_z_interpolated=xNew<IssmDouble>(1);
-					Love_tk2_interpolated=xNew<IssmDouble>(1);
-					Love_th2_interpolated=xNew<IssmDouble>(1);
-					if (horiz) Love_tl2_interpolated=xNew<IssmDouble>(1);
+					U_viscoelastic_interpolated=xNew<IssmDouble>(M);
+					if (horiz) H_viscoelastic_interpolated=xNew<IssmDouble>(M);
 #endif
-
-					Pmtf_col_interpolated=love_pmtf_colinear;
-					Pmtf_ortho_interpolated=love_pmtf_ortho;
-					Pmtf_z_interpolated[0]=1.0+love_k[2];
-					Love_tk2_interpolated[0]=love_tk[2];
-					Love_th2_interpolated[0]=love_th[2];
-					if (horiz) Love_tl2_interpolated[0]=love_tl[2];
+					xMemCpy<IssmDouble>(U_viscoelastic_interpolated,U_viscoelastic,M);
+					if (horiz) xMemCpy<IssmDouble>(H_viscoelastic_interpolated,H_viscoelastic,M);
+
+					if(rotation){ //if this cpu handles degree 2
+#ifdef _HAVE_AD_
+						Pmtf_col_interpolated=xNew<IssmDouble>(1,"t");
+						Pmtf_ortho_interpolated=xNew<IssmDouble>(1,"t");
+						Pmtf_z_interpolated=xNew<IssmDouble>(1,"t");
+						Love_tk2_interpolated=xNew<IssmDouble>(1,"t");
+						Love_th2_interpolated=xNew<IssmDouble>(1,"t");
+						if (horiz) Love_tl2_interpolated=xNew<IssmDouble>(1,"t");
+#else
+						Pmtf_col_interpolated=xNew<IssmDouble>(1);
+						Pmtf_ortho_interpolated=xNew<IssmDouble>(1);
+						Pmtf_z_interpolated=xNew<IssmDouble>(1);
+						Love_tk2_interpolated=xNew<IssmDouble>(1);
+						Love_th2_interpolated=xNew<IssmDouble>(1);
+						if (horiz) Love_tl2_interpolated=xNew<IssmDouble>(1);
+#endif
+
+						Pmtf_col_interpolated[0]=love_pmtf_colinear[0];
+						Pmtf_ortho_interpolated[0]=love_pmtf_ortho[0];
+						Pmtf_z_interpolated[0]=1.0+love_k[2];
+						Love_tk2_interpolated[0]=love_tk[2];
+						Love_th2_interpolated[0]=love_th[2];
+						if (horiz) Love_tl2_interpolated[0]=love_tl[2];
+					}
+
 				}
 			}	
-
 			/*Save our precomputed tables into parameters*/
 			parameters->AddObject(new DoubleVecParam(SealevelchangeGSelfAttractionEnum,G_gravi,M));
+			parameters->AddObject(new DoubleVecParam(SealevelchangeGViscoElasticEnum,G_viscoelastic_interpolated,M*nt));
 			if(viscous || elastic){
-				parameters->AddObject(new DoubleVecParam(SealevelchangeGViscoElasticEnum,G_viscoelastic_interpolated,M*nt));
 				parameters->AddObject(new DoubleVecParam(SealevelchangeUViscoElasticEnum,U_viscoelastic_interpolated,M*nt));
 				if(horiz)parameters->AddObject(new DoubleVecParam(SealevelchangeHViscoElasticEnum,H_viscoelastic_interpolated,M*nt));
@@ -582,9 +597,12 @@
 				}
 			}
-
 			/*free resources: */
 			xDelete<IssmDouble>(G_gravi);
 			xDelete<IssmDouble>(G_gravi_local);
+			xDelete<IssmDouble>(G_viscoelastic);
+			xDelete<IssmDouble>(G_viscoelastic_local);
+			xDelete<IssmDouble>(G_viscoelastic_interpolated);
 			if(elastic){
+				xDelete<IssmDouble>(love_timefreq);
 				xDelete<IssmDouble>(love_h);
 				xDelete<IssmDouble>(love_k);
@@ -593,16 +611,25 @@
 				xDelete<IssmDouble>(love_tk);
 				xDelete<IssmDouble>(love_tl);
-				xDelete<IssmDouble>(G_viscoelastic);
-				xDelete<IssmDouble>(G_viscoelastic_local);
+
+				xDelete<IssmDouble>(G_viscoelastic_interpolated);
 				xDelete<IssmDouble>(U_viscoelastic);
+				xDelete<IssmDouble>(U_viscoelastic_interpolated);
 				xDelete<IssmDouble>(U_viscoelastic_local);
+				xDelete<IssmDouble>(U_viscoelastic_interpolated);
 				if(horiz){
 					xDelete<IssmDouble>(H_viscoelastic);
+					xDelete<IssmDouble>(H_viscoelastic_interpolated);
 					xDelete<IssmDouble>(H_viscoelastic_local);
+					xDelete<IssmDouble>(H_viscoelastic_interpolated);
 				}
 				if(rotation){
 					xDelete<IssmDouble>(love_pmtf_colinear);
 					xDelete<IssmDouble>(love_pmtf_ortho);
-
+					xDelete<IssmDouble>(Pmtf_col_interpolated);
+					xDelete<IssmDouble>(Pmtf_ortho_interpolated);
+					xDelete<IssmDouble>(Pmtf_z_interpolated);
+					xDelete<IssmDouble>(Love_tk2_interpolated);
+					xDelete<IssmDouble>(Love_th2_interpolated);
+					if (horiz) xDelete<IssmDouble>(Love_tl2_interpolated);
 				}
 			}
@@ -632,4 +659,5 @@
 	iomodel->DeleteData(&requestedoutputs,numoutputs,"md.solidearth.requested_outputs");
 	/*}}}*/
+
 }/*}}}*/
 
Index: issm/trunk/src/c/analyses/SealevelchangeAnalysis.h
===================================================================
--- issm/trunk/src/c/analyses/SealevelchangeAnalysis.h	(revision 27035)
+++ issm/trunk/src/c/analyses/SealevelchangeAnalysis.h	(revision 27232)
@@ -16,4 +16,5 @@
 		void CreateLoads(Loads* loads, IoModel* iomodel);
 		void CreateNodes(Nodes* nodes,IoModel* iomodel,bool isamr=false);
+		static void DeleteBarystaticContributionsParam(FemModel* femmodel);
 		int  DofsPerNode(int** doflist,int domaintype,int approximation);
 		void UpdateElements(Elements* elements,Inputs* inputs,IoModel* iomodel,int analysis_counter,int analysis_type);
Index: issm/trunk/src/c/analyses/SmbAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/SmbAnalysis.cpp	(revision 27035)
+++ issm/trunk/src/c/analyses/SmbAnalysis.cpp	(revision 27232)
@@ -249,4 +249,5 @@
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.aIdx",SmbAIdxEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.eIdx",SmbEIdxEnum));
+			parameters->AddObject(iomodel->CopyConstantObject("md.smb.tcIdx",SmbTcIdxEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.swIdx",SmbSwIdxEnum));
 			parameters->AddObject(iomodel->CopyConstantObject("md.smb.denIdx",SmbDenIdxEnum));
Index: issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 27035)
+++ issm/trunk/src/c/analyses/StressbalanceAnalysis.cpp	(revision 27232)
@@ -502,5 +502,5 @@
 	}
 
-	/*free ressources: */
+	/*Free resources: */
 	iomodel->DeleteData(penalties,"md.stressbalance.vertex_pairing");
 
@@ -1308,5 +1308,5 @@
 	solution->SetValues(numdof,doflist,values,INS_VAL);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete gauss;
 	xDelete<IssmDouble>(values);
@@ -2143,5 +2143,5 @@
 	element->AddBasalInput(VelEnum,vel,element->GetElementType());
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(vel);
 	xDelete<IssmDouble>(vz);
@@ -2749,5 +2749,5 @@
 	element->AddBasalInput(VyBaseEnum,vy,element->GetElementType());
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(vel);
 	xDelete<IssmDouble>(vz);
@@ -3275,5 +3275,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(vel);
 	xDelete<IssmDouble>(vx);
@@ -3343,5 +3343,5 @@
 	solution->SetValues(numdof,doflist,values,INS_VAL);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete gauss;
 	xDelete<IssmDouble>(values);
@@ -3992,5 +3992,5 @@
 	element->AddInput(VelEnum,vel,element->GetElementType());
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(vel);
 	xDelete<IssmDouble>(vz);
@@ -6505,5 +6505,5 @@
 	if(pnumdof>0) solution->SetValues(pnumdof,pdoflist,pvalues,INS_VAL);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete gauss;
 	xDelete<int>(pdoflist);
@@ -6668,5 +6668,5 @@
 	if(dim==3) element->AddInput(VzEnum,vz,v_interp);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(pressure);
 	xDelete<IssmDouble>(vel);
@@ -8566,5 +8566,5 @@
 	element->AddInput(PressureEnum,pressure,P1Enum);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(pressure);
 	xDelete<IssmDouble>(vel);
@@ -8669,5 +8669,5 @@
 	element->AddInput(PressureEnum,pressure,P1Enum);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(pressure);
 	xDelete<IssmDouble>(vel);
@@ -8760,5 +8760,5 @@
 	element->AddInput(PressureEnum,pressure,P1Enum);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(surface);
 	xDelete<IssmDouble>(pressure);
Index: issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 27035)
+++ issm/trunk/src/c/analyses/StressbalanceSIAAnalysis.cpp	(revision 27232)
@@ -554,5 +554,5 @@
 	solution->SetValues(numdof,doflist,values,INS_VAL);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	delete gauss;
 	xDelete<int>(doflist);
@@ -630,5 +630,5 @@
 	element->AddInput(PressureEnum,pressure,P1Enum);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(thickness);
 	xDelete<IssmDouble>(surface);
Index: issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 27035)
+++ issm/trunk/src/c/analyses/StressbalanceVerticalAnalysis.cpp	(revision 27232)
@@ -657,5 +657,5 @@
 	element->AddInput(VelEnum,vel,P1Enum);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(surface);
 	xDelete<IssmDouble>(pressure);
Index: issm/trunk/src/c/analyses/ThermalAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 27035)
+++ issm/trunk/src/c/analyses/ThermalAnalysis.cpp	(revision 27232)
@@ -65,5 +65,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	iomodel->DeleteData(spcvector,"md.thermal.spctemperature");
 	iomodel->DeleteData(spcvectorstatic,"md.thermal.spctemperature");
@@ -839,5 +839,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(values);
 	xDelete<IssmDouble>(surface);
Index: issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp
===================================================================
--- issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp	(revision 27035)
+++ issm/trunk/src/c/analyses/UzawaPressureAnalysis.cpp	(revision 27232)
@@ -287,5 +287,5 @@
 	}
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<IssmDouble>(values);
 	xDelete<IssmDouble>(valueslambda);
Index: issm/trunk/src/c/analyses/analyses.h
===================================================================
--- issm/trunk/src/c/analyses/analyses.h	(revision 27035)
+++ issm/trunk/src/c/analyses/analyses.h	(revision 27232)
@@ -11,4 +11,5 @@
 #include "./AdjointBalancethickness2Analysis.h"
 #include "./AdjointHorizAnalysis.h"
+#include "./AgeAnalysis.h"
 #include "./BalancethicknessAnalysis.h"
 #include "./Balancethickness2Analysis.h"
Index: issm/trunk/src/c/classes/Cfdragcoeffabsgrad.cpp
===================================================================
--- issm/trunk/src/c/classes/Cfdragcoeffabsgrad.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Cfdragcoeffabsgrad.cpp	(revision 27232)
@@ -69,5 +69,13 @@
 /*}}}*/
 void Cfdragcoeffabsgrad::Marshall(MarshallHandle* marshallhandle){/*{{{*/
-	_error_("not implemented yet!"); 
+
+	/*ok, marshall operations: */
+   int object_enum=CfdragcoeffabsgradEnum;
+   marshallhandle->call(object_enum);
+
+	marshallhandle->call(this->definitionenum);
+	marshallhandle->call(this->name);
+	marshallhandle->call(this->weights_enum);
+	marshallhandle->call(this->timepassedflag);
 } 
 /*}}}*/
Index: issm/trunk/src/c/classes/Dakota/IssmDirectApplicInterface.h
===================================================================
--- issm/trunk/src/c/classes/Dakota/IssmDirectApplicInterface.h	(revision 27035)
+++ issm/trunk/src/c/classes/Dakota/IssmDirectApplicInterface.h	(revision 27232)
@@ -118,5 +118,5 @@
 				}
 
-				/*Free ressources:*/
+				/*Free resources:*/
 				xDelete<IssmDouble>(variables);
 				for(i=0;i<numACV;i++){
Index: issm/trunk/src/c/classes/Dakota/IssmParallelDirectApplicInterface.cpp
===================================================================
--- issm/trunk/src/c/classes/Dakota/IssmParallelDirectApplicInterface.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Dakota/IssmParallelDirectApplicInterface.cpp	(revision 27232)
@@ -134,5 +134,5 @@
 		}
 
-		/*Free ressources:*/
+		/*Free resources:*/
 		xDelete<IssmDouble>(variables);
 		for(i=0;i<numACV;i++){
Index: issm/trunk/src/c/classes/Elements/Element.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Element.cpp	(revision 27232)
@@ -22,4 +22,5 @@
 #include "../Inputs/ControlInput.h"
 #include "../Inputs/ArrayInput.h"
+#include "../Inputs/IntArrayInput.h"
 /*}}}*/
 #define MAXVERTICES 6 /*Maximum number of vertices per element, currently Penta, to avoid dynamic mem allocation*/
@@ -1533,5 +1534,5 @@
 	solution->SetValues(numnodes,doflist,values,INS_VAL);
 
-	/*Free ressources:*/
+	/*Free resources:*/
 	xDelete<int>(doflist);
 	xDelete<IssmDouble>(values);
@@ -4012,4 +4013,5 @@
 	int        aIdx=0;
 	int        eIdx=0;
+	int        tcIdx=0;
 	int        denIdx=0;
 	int        dsnowIdx=0;
@@ -4096,4 +4098,5 @@
 	parameters->FindParam(&aIdx,SmbAIdxEnum);
 	parameters->FindParam(&eIdx,SmbEIdxEnum);
+	parameters->FindParam(&tcIdx,SmbTcIdxEnum);
 	parameters->FindParam(&denIdx,SmbDenIdxEnum);
 	parameters->FindParam(&swIdx,SmbSwIdxEnum);
@@ -4348,5 +4351,5 @@
 	}
 	/*Thermal profile computation:*/
-	if(isthermal)thermo(&EC, &T, &ulw, re, dz, d, swf, dlw, Ta, V, eAir, pAir, eIdx, teValue, dulwrfValue, teThresh, W[0], smb_dt, m, Vz, Tz, thermo_scaling,rho_ice,this->Sid(),isconstrainsurfaceT,isdeltaLWup);
+	if(isthermal)thermo(&shf, &lhf, &EC, &T, &ulw, re, dz, d, swf, dlw, Ta, V, eAir, pAir, tcIdx, eIdx, teValue, dulwrfValue, teThresh, W[0], smb_dt, dzMin, m, Vz, Tz, thermo_scaling,rho_ice,this->Sid(),isconstrainsurfaceT,isdeltaLWup);
 
 	/*Change in thickness of top cell due to evaporation/condensation  assuming same density as top cell.
@@ -4364,14 +4367,7 @@
 	if(isdensification)densification(&d,&dz, T, re, denIdx, aIdx, swIdx, adThresh, C, smb_dt, Tmean,rho_ice,m,this->Sid());
 
-	/*Calculate upward longwave radiation flux [W m-2] not used in energy balance. Calculated for every
-	 * sub-time step in thermo equations*/
-	//ulw = 5.67E-8 * pow(T[0],4.0) * teValue; // + deltatest here
-
 	/*Calculate net longwave [W m-2]*/
 	meanULW = meanULW + ulw*smb_dt/dt;
 	netLW = netLW + (dlw - ulw)*smb_dt/dt;
-
-	/*Calculate turbulent heat fluxes [W m-2]*/
-	if(isturbulentflux)turbulentFlux(&shf, &lhf, &dayEC, Ta, T[0], V, eAir, pAir, d[0], W[0], Vz, Tz,rho_ice,this->Sid());
 
 	/*Verbose some results in debug mode: {{{*/
Index: issm/trunk/src/c/classes/Elements/Element.h
===================================================================
--- issm/trunk/src/c/classes/Elements/Element.h	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/Element.h	(revision 27232)
@@ -404,5 +404,5 @@
 		virtual void       SealevelchangeGeometrySubElementKernel(SealevelGeometry* slgeom)=0;
 		virtual void       SealevelchangeShift(GrdLoads* loads, IssmDouble offset, SealevelGeometry* slgeom)=0;
-		virtual void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae)=0;
+		virtual void       SealevelchangeGeometryInitial(IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae, int* lids)=0;
 		virtual void       SealevelchangeGeometryCentroidLoads(SealevelGeometry* slgeom, IssmDouble* xxe, IssmDouble* yye, IssmDouble* zze, IssmDouble* areae)=0;
 		virtual void       SealevelchangeGeometrySubElementLoads(SealevelGeometry* slgeom, IssmDouble* areae)=0;
Index: issm/trunk/src/c/classes/Elements/ElementHook.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/ElementHook.cpp	(revision 27035)
+++ issm/trunk/src/c/classes/Elements/ElementHook.cpp	(revision 27232)
@@ -120,5 +120,5 @@
 	if(this->hneighbors)this->hneighbors->Marshall(marshallhandle);
 
-	/*Free ressources: */
+	/*Free resources: */
 	if(hnodesi_null) xDelete<bool>(hnodesi_null);
 
